diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 4a0b5b0f6..79643b5ff 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -290,6 +290,35 @@ fun generateMcPatchesFile(inputDir: File, outputDir: File, sbom: File) {
     patchMC.writeText(gson.toJson(json))
 }
 
+val testShaders by tasks.registering {
+    outputs.upToDateWhen { false }
+
+    val shaderDir = project.layout.projectDirectory.dir("/src/main/resources/shaders/").asFile
+
+    shaderDir.walkTopDown().forEach { file ->
+        run {
+            if (file.isFile) {
+                val type = when(file.extension) {
+                    "fsh" -> "frag"
+                    "gsh" -> "geom"
+                    "vsh" -> "vert"
+                    else -> throw RuntimeException("Unknown shader type '${file.extension}' in shader '${file.canonicalPath}'!")
+                }
+                val command = "glslangValidator ${file.canonicalPath} -S $type"
+                val process = command.runCommand(shaderDir)
+                process.waitFor(60, TimeUnit.MINUTES)
+                if (process.exitValue() != 0) {
+                    System.err.println("Failed to compile shader file:///${file.canonicalPath.replace("\\", "/")}")
+                    System.out.print(process.inputStream.bufferedReader().readText())
+                    throw RuntimeException(process.errorStream.bufferedReader().readText())
+                } else{
+                    print(process.inputStream.bufferedReader().readText())
+                }
+            }
+        }
+    }
+}
+
 tasks.cyclonedxBom {
     setIncludeConfigs(listOf("runtimeClasspath"))
     setSkipConfigs(listOf("compileClasspath", "testCompileClasspath"))
@@ -321,7 +350,7 @@ tasks.withType(JavaCompile::class.java) {
 }
 
 tasks.withType(Jar::class.java) {
-    dependsOn(tasks.test)
+    dependsOn(tasks.test, "testShaders")
 }
 
 tasks.test {
@@ -336,3 +365,14 @@ sourceSets.main {
     }
 }
 
+fun String.runCommand(workingDir: File): Process {
+    println("Running command $this")
+    val parts = this.split("\\s".toRegex())
+    val proc = ProcessBuilder(*parts.toTypedArray())
+        .directory(workingDir)
+        .redirectOutput(ProcessBuilder.Redirect.PIPE)
+        .redirectError(ProcessBuilder.Redirect.PIPE)
+        .start()
+    return proc
+}
+
diff --git a/game/client/src/main/java/net/minecraft/client/GLAllocation.java b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
index 9c33e6719..a21921e5f 100644
--- a/game/client/src/main/java/net/minecraft/client/GLAllocation.java
+++ b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
@@ -8,21 +8,11 @@ import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL11;
 
 public class GLAllocation {
-
-//	public static IntList displayLists = new IntArrayList();
+	
 	public static IntList textureNames = new IntArrayList();
 
 	public GLAllocation() {}
 
-	@Deprecated
-	public static synchronized int generateDisplayLists(int range) {
-//		int list = GL11.glGenLists(range);
-//		displayLists.add(list);
-//		displayLists.add(range);
-//		return list;
-		return 0;
-	}
-
 	public static synchronized int generateTexture() {
 		int tex = GL11.glGenTextures();
 		textureNames.add(tex);
@@ -39,20 +29,7 @@ public class GLAllocation {
 		}
 	}
 
-	@Deprecated
-	public static synchronized void deleteDisplayList(int displayList)
-	{
-//		int displayListIndex = displayLists.indexOf(displayList);
-//		if (displayListIndex < 0) return;
-//		GL11.glDeleteLists(displayLists.getInt(displayListIndex), displayLists.getInt(displayListIndex + 1));
-//		displayLists.removeInt(displayListIndex);
-//		displayLists.removeInt(displayListIndex);
-	}
-
 	public static synchronized void deleteTexturesAndDisplayLists() {
-//		for (int i = 0; i < displayLists.size(); i += 2) {
-//			GL11.glDeleteLists(displayLists.getInt(i), displayLists.getInt(i + 1));
-//		}
 
 		IntBuffer intbuffer = BufferUtils.createIntBuffer(textureNames.size());
 		for (Integer textureName : textureNames) {
@@ -61,7 +38,6 @@ public class GLAllocation {
 
 		intbuffer.flip();
 		GL11.glDeleteTextures(intbuffer);
-//		displayLists.clear();
 		textureNames.clear();
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index f9f4fc7cb..92594d1fb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -16,7 +16,6 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.HashMap;
@@ -442,7 +441,6 @@ public class ScreenConsole extends Screen {
             heightLines = Math.max(1, ((this.height - (PADDING + PADDING + PADDING + PADDING)) / LINE_HEIGHT) - 1);
         }
 
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
         drawRect(0, 0, this.width, getMaxY(), 0xDF_00_00_00);
 
         this.logRenderer.render(PADDING, PADDING, heightLines - this.inputRenderer.getHeightLines());
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
index 1fccc142a..0d4807527 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
@@ -5,7 +5,6 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuContainer;
 import net.minecraft.core.player.inventory.container.Container;
-import org.lwjgl.opengl.GL11;
 
 public class ScreenContainer extends ScreenContainerAbstract {
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index f60947684..26727e541 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -4,13 +4,13 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.ClickableLabelElement;
 import net.minecraft.client.gui.DrawableSurfaceElement;
 import net.minecraft.client.gui.TexturedButtonElement;
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.gui.drawing.DrawableEditor;
 import net.minecraft.client.gui.drawing.IDrawableSurface;
@@ -117,7 +117,7 @@ public class ScreenFlagEditor
         this.drawOverlaySurface.colors = colors;
 
         GLRenderer.enableState(State.BLEND);
-        GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+        GLRenderer.setBlendFunc(BlendFactor.ONE_MINUS_SRC_ALPHA, BlendFactor.SRC_COLOR);
         this.flagSurface.render(this.canvasX, this.canvasY);
         GLRenderer.disableState(State.BLEND);
         this.drawOverlaySurface.render(this.canvasX, this.canvasY);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
index 4be4956b8..df2e2866b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
@@ -11,7 +11,6 @@ import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 import org.slf4j.Logger;
 
 public class ScreenMissingMinecraft extends Screen {
@@ -64,7 +63,6 @@ public class ScreenMissingMinecraft extends Screen {
 
     public void drawBackground(float partialTick) {
         GLRenderer.globalSetLightEnabled(false);
-        GL11.glDisable(GL11.GL_FOG);
 
         TessellatorGeneral tessellator = GLRenderer.getTessellator();
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/block/cobbled_netherrack_mossy.png").bind();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/index/GuidebookPageIndex.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/index/GuidebookPageIndex.java
index 53d2fcf23..060b49b00 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/index/GuidebookPageIndex.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/index/GuidebookPageIndex.java
@@ -8,7 +8,6 @@ import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
-import org.lwjgl.opengl.GL11;
 
 import java.util.List;
 
@@ -58,9 +57,7 @@ public class GuidebookPageIndex
 
             int lineStrWidth = MathHelper.ceil(sr.stringWidthDouble(lineStr));
 
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
             drawRect(x + 10 + lineStrWidth + 4 + lineXMod, y + yOffset + 10 + j * 12 + 6, x + 158 - 10 - pageStrWidth - 4, y + yOffset + 10 + j * 12 + 7, 0xFFA0A0A0);
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 803b2f89a..2dc9aa35d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render;
 
+import static net.minecraft.client.render.uniform.UniformBlock.N;
 import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.world.WorldClient;
@@ -50,7 +51,7 @@ public class FogManager {
     }
 
     public @NotNull FogState setupFog(int fogMode, float farPlaneDistance, float partialTick, @NotNull FogState dest) {
-        dest.fogColor.set(this.fogRed, this.fogGreen, this.fogBlue, 0.5f);
+        dest.fogColor.set(this.fogRed, this.fogGreen, this.fogBlue);
 
         byte cameraState;
         if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
@@ -184,7 +185,7 @@ public class FogManager {
         }
 
         public @NotNull FogState reset() {
-            this.fogColor.set(0, 0, 0, 0);
+            this.fogColor.set(0, 0, 0);
             this.fogMode = Mode.EXP;
             this.fogStart = 0f;
             this.fogEnd = 1f;
@@ -216,5 +217,23 @@ public class FogManager {
             EXP,
             EXP2
         }
+
+        @Override
+        public boolean equals(Object obj) {
+            if (obj instanceof FogState otherState) {
+                return
+                    otherState.fogColor.equals(this.fogColor) &&
+                        otherState.fogStart == this.fogStart &&
+                        otherState.fogEnd == this.fogEnd &&
+                        otherState.fogMode == this.fogMode &&
+                        otherState.fogDensity == this.fogDensity;
+            }
+            return false;
+        }
+
+        public static int uboSize() {
+            return 8 * N; // 4N for color and 1N for each scalar (mode, start, end, and density)
+        }
+
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 71754b6de..bcc030c1e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -3,9 +3,12 @@ package net.minecraft.client.render;
 import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
+import org.joml.Matrix4f;
 import org.joml.Vector3f;
 import org.joml.Vector4f;
 
+import static net.minecraft.client.render.uniform.UniformBlock.N;
+
 public final class Lighting {
     private Lighting() {
     }
@@ -68,6 +71,20 @@ public final class Lighting {
             reset();
         }
 
+        public @NotNull LightSource set(@NotNull LightSource source) {
+            this.ambient.set(source.ambient);
+            this.diffuse.set(source.diffuse);
+            this.specular.set(source.specular);
+            this.position.set(source.position);
+            this.spotDirection.set(source.spotDirection);
+            this.spotExponent = source.spotExponent;
+            this.spotCutoff = source.spotCutoff;
+            this.constantAttenuation = source.constantAttenuation;
+            this.linearAttenuation = source.linearAttenuation;
+            this.quadraticAttenuation = source.quadraticAttenuation;
+            return this;
+        }
+
         public void reset() {
             this.ambient.set(0, 0, 0, 1);
             this.diffuse.set(0, 0, 0, 1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 8b159ac28..2e29a1c71 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -970,8 +970,8 @@ public class RenderGlobal
         // Hack for not needing to record the cloud buffer twice
         GLRenderer.setColorMask(true, true, true, true);
         GLRenderer.getShader().bind();
-        GL41.glBindVertexArray(tessellator.vao);
-        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, tessellator.vbo);
+        GL41.glBindVertexArray(tessellator.vaos[tessellator.config]);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, tessellator.vbos[tessellator.config]);
         GL41.glDrawArrays(tessellator.drawMode.cap, 0, tessellator.vertexCount);
         GL41.glBindVertexArray(0);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index ad6a23eae..1d1294cab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -5,6 +5,7 @@ import java.util.Random;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityLightning;
@@ -19,12 +20,13 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
     @Override
     public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityLightning lightning, double x, double y, double z,
                        float yaw, float partialTick) {
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR_WORLD);
         GLRenderer.globalSetLightEnabled(false);
         GLRenderer.enableState(State.BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
-        double ad[] = new double[8];
-        double ad1[] = new double[8];
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
+        double[] ad = new double[8];
+        double[] ad1 = new double[8];
         double d3 = 0.0D;
         double d4 = 0.0D;
         Random random = new Random(lightning.seed);
@@ -60,7 +62,7 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
                     }
                     tessellator.startDrawing(DrawMode.TRIANGLE_STRIP);
                     float f2 = 0.5F;
-                    tessellator.setColor4f(0.9F * f2, 0.9F * f2, 1.0F * f2, 0.3F);
+                    tessellator.setColor4f(0.9F * f2, 0.9F * f2, f2, 0.3F);
                     double d9 = 0.1D + (double) i * 0.2D;
                     if (k == 0) {
                         d9 *= (double) j1 * 0.1D + 1.0D;
@@ -99,7 +101,7 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
 
         GLRenderer.disableState(State.BLEND);
         GLRenderer.globalSetLightEnabled(true);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.popFrame();
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index f166ff51f..dedc841a1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -2,14 +2,15 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.block.Blocks;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT> {
     public EntityRendererTNT() {
@@ -38,16 +39,17 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT> {
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
         model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
         if ((tnt.fuse / 5) % 2 == 0) {
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR_WORLD);
             GLRenderer.globalSetLightEnabled(false);
             GLRenderer.enableState(State.BLEND);
-            GL11.glBlendFunc(770, 772);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.DST_ALPHA);
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, f3);
             model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             GLRenderer.disableState(State.BLEND);
             GLRenderer.globalSetLightEnabled(true);
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            GLRenderer.popFrame();
         }
         GLRenderer.popFrame();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
index fa28ac2ce..f4728437a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
@@ -18,20 +18,25 @@ public class MobRendererSheep extends MobRenderer<MobSheep> {
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSheep entity, final float brightness, final float partialTick, final int layer) {
         final StaticEntityModel model;
         switch (layer) {
-            case 1:
+            case 1: {
                 final int colorIndex = entity.getFleeceColor().blockMeta;
                 GLRenderer.setColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][0], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][1], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][2]);
                 model = getModel("main");
                 bindTexture("/assets/minecraft/textures/entity/sheep/wool_overlay.png");
                 break;
-            case 2:
+            }
+            case 2: {
+                final int colorIndex = entity.getFleeceColor().blockMeta;
+                GLRenderer.setColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][0], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][1], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][2]);
                 model = getModel("wool");
                 bindTexture("/assets/minecraft/textures/entity/sheep/wool_overlay.png");
                 break;
+            }
             case 0:
-            default:
+            default: {
                 model = getModel("main");
                 break;
+            }
         }
         model.resetBones();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
index 50e03f9e1..52c3b02cb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
@@ -68,7 +68,7 @@ public class FontDefault extends FontFile {
         final double width = uWidth/2d;
         final double height = vHeight/2d;
 
-        tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
+        tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
 
         return (fLower - fUpper)/2d + 1;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
index 58dc898fc..a99be0772 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
@@ -128,7 +128,7 @@ public class FontFile implements Font {
         final double width = uWidth/2d;
         final double height = vHeight/2d;
 
-        tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
+        tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
 
         return (fLower - fUpper)/2d + 1;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
index 254252278..d7b56d405 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
@@ -49,7 +49,7 @@ public class FontMonospace extends FontFile{
             final double width = uWidth/2d;
             final double height = vHeight/2d;
 
-            tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
+            tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
         }
         return MONOSPACE_WIDTH / 2d + 1;
     }
